#include <stdio.h>
#include <stdlib.h>
#define MAX 1000000
long p[MAX];

/* Implementace selectsortu. __attribute__ ((noinline,noclone)) zabrání gcc nebo
   clangu vnořit selectsort do zbytku kódu a optimalizovat.  */
__attribute__ ((noinline,noclone))
void
selectsort (long n)
{
  long i;
  for (i = 0; i < n; i++)
    {
      long m = i;
      long j;
      for (j = i; j < n; j++)
	if (p[j] < p[m])
	  m = j;
      long x = p[i];
      p[i] = p[m];
      p[m] = x;
    }
}

/* Benchmark co spustí smyčku pro parametr N, Mx. parametr R vypíná a zapíná
   selectsort aby šel měřit overhead.  */
int
main (int argc, char **argv)
{
  if (argc != 4)
    {
      printf ("Volej s parametery N M R.\n"
	      "N udava pocet prvku,\n"
	      "M je pocet opakovani vnitrni smycky.\n"
	      "Pokud R je nenulove provede se trideni\n");
      return 1;
    }
  int n = atoi (argv[1]);
  int m = atoi (argv[2]);
  int r = atoi (argv[3]);
  if (n <= 0 || n > MAX)
    {
      printf ("N neni cislo v intervalu 0...%i", MAX);
      return 1;
    }
  if (m <= 0)
    {
      printf ("M neni kladne cislo");
      return 1;
    }
  if (r != 0 && r != 1)
    {
      printf ("R neni 0 nebo 1");
      return 1;
    }

  int o;
  for (o = 0; o < m; o++)
    {
      int i;
      for (i = 0; i < n; i++)
	p[i] = n - i;
      asm __volatile ("":::"memory");	/* Zabran GCC a clangu optimalizovat. */
      selectsort (r ? n : 0);
    }

  if (r)
    {
      int i;
      for (i = 0; i < n; i++)
        if (p[i] != i + 1)
          abort ();
    }
  return 0;
}
